using System;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace CSSamples.Samples
{
    public partial class DisplayASimpleMap : System.Web.UI.Page
    {
        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
                Map1.CurrentExtent = new RectangleShape(-125, 72, 50, -46);
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                Map1.MapTools.MeasureMapTool.Enabled = true;
                Map1.MapTools.MeasureMapTool.MeasureType = MeasureType.None;
                Map1.MapTools.AnimationPanMapTool.Enabled = true;

                WorldMapKitWmsWebOverlay worldMapKitOverlay = new WorldMapKitWmsWebOverlay();
                Map1.CustomOverlays.Add(worldMapKitOverlay);

                CreateVehicleLayer();
            }
        }

        private void CreateVehicleLayer()
        {
            InMemoryMarkerOverlay vehicleOverlay = new InMemoryMarkerOverlay("Vehicles");

            vehicleOverlay.FeatureSource.Open();
            vehicleOverlay.Columns.Add(new FeatureSourceColumn("Status", "string", 50));
            vehicleOverlay.FeatureSource.Close();

            vehicleOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.ContentHtml = "Truck A" + " [#Status#]";
            vehicleOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.HasCloseButton = true;
            vehicleOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.Width = 100;
            vehicleOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.Height = 30;
            vehicleOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.BackgroundColor = GeoColor.StandardColors.LightBlue;
            vehicleOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.BorderColor = GeoColor.StandardColors.Black;
            vehicleOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.BorderWidth = 1;
            vehicleOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage.ImageOffsetX = -10.5f;
            vehicleOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage.ImageOffsetY = -25f;
            vehicleOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage.ImageWidth = 21;
            vehicleOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage.ImageHeight = 25;

            //vehicleOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage = new WebImage("../i/RubbishTruck.jpg", 21, 25);
            // Make it available all over the zoomlevels.
            vehicleOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            vehicleOverlay.IsVisibleInOverlaySwitcher = true;
            Map1.CustomOverlays.Add(vehicleOverlay);
        }

        protected void UpdateMapButton_Click(object sender, EventArgs e)
        {
            InMemoryMarkerOverlay vehicleOverlay = (InMemoryMarkerOverlay)Map1.CustomOverlays["Vehicles"];
            Feature feature = new Feature(-94.48242, 38.75977);

            feature.ColumnValues.Add("Status", "F");
            vehicleOverlay.Features.Add(feature);
        }
    }
}
